###############################################################################
# GamesSet.pm                                                                 #
# By XTC: http://www.yabbserver.com                                           #
# 2.6.11 updated by Dandello: http://yabbforumsoftware.com                    #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.6.11                                                 #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2015 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################

$gamessetplver = 'YaBB 2.6.11 $Revision: 1.02 $';
if ($action eq 'detailedversion') { return 1; }

LoadLanguage('Mods/Games');

if(!-e("$vardir/Mods/onlinegames.txt"))  {
    GamesSet2();
}

require "$vardir/Mods/onlinegames.txt";

sub GamesSet {
    is_admin_or_gmod();
    my ($ongameschecked);
    @ExistGames = ('airhockey','amoebas','asteroids','blackjack','browsersoccer','deepbluesea','delirium','hangman','hexxagon','invaders','javanoid','magicmath','minigolf','moorhenne','pacman','puzzle','simon','simplepong','snake','snowcraft','spacewar','warp','wastem');

### Add Plugin Games Begin ###

    $gyroball = 'gyroball'; ## Added for Gyroball Game Plugin
    push @ExistGames, $gyroball; ## Added for Gyroball Game Plugin
    $magicballs = 'magicballs'; ## Added for Magicballs Game Plugin
    push @ExistGames, $magicballs; ## Added for Magicballs Game Plugin
    $reelgold = 'reelgold'; ## Added for Reel Gold Game Plugin
    push @ExistGames, $reelgold; ## Added for Reel Gold Game Plugin
    $donkeykong = 'donkeykong'; ## Added for donkeykong Game Plugin
    push @ExistGames, $donkeykong; ## Added for donkeykong Game Plugin
    $battleships = 'battleships'; ## Added for Battleships Game Plugin
    push @ExistGames, $battleships; ## Added for Battleships Game Plugin
    $camperstrike = 'camperstrike'; ## Added for camperstrike Game Plugin
    push @ExistGames, $camperstrike; ## Added for camperstrike Game Plugin
    $mahjongg = 'mahjongg'; ## Added for mahjongg Game Plugin
    push @ExistGames, $mahjongg; ## Added for mahjongg Game Plugin
    $paintball = 'paintball'; ## Added for paintball Game Plugin
    push @ExistGames, $paintball; ## Added for paintball Game Plugin
    $penguin = 'penguin'; ## Added for Smack The Penguin Game Plugin
    push @ExistGames, $penguin; ## Added for Smack The Penguin Game Plugin
    $pingusports = 'pingusports'; ## Added for pingusports Game Plugin
    push @ExistGames, $pingusports; ## Added for pingusports Game Plugin
    $pool = 'pool'; ## Added for Pool - Billiards Game Plugin
    push @ExistGames, $pool; ## Added for Pool - Billiards Game Plugin
#### Add Plugin Games End ####

    # figure out what to print
    if    ($Games_Active || $Games_Active eq "") { $ongamesactchecked = 'checked="checked"'; }
    if    ($Show_GamesButton == 0)      { $cgam1  = ' selected="selected"'; }
    elsif ($Show_GamesButton == 1)      { $cgam2  = ' selected="selected"'; }
    elsif ($Show_GamesButton == 2)      { $cgam3  = ' selected="selected"'; }
    if ($GamesPopup) { $games_popup_checked = ' checked="checked" ' ;}

    require Admin::ManageBoards;
    $gamesperms = $GamesPerms;
    $gamesperms =~ s/,/, /gxsm;
    $gamesperms = DrawPerms($gamesperms);

    $yymain .= qq~
<form action="$adminurl?action=games_set2" method="post">
    <div class="bordercolor rightboxdiv">
    <table class="border-space pad-cell" style="margin-bottom: .5em;">
		<colgroup>
			<col width="50%" />
			<col width="50%" />
		</colgroup>
		<tr>
			<td class="titlebg" colspan="2"><img src="$modimgurl/Games/onlinegames.gif" alt="" /> <b>$games{'admin1'}</b></td>
		</tr><tr>
			<td class="catbg center" colspan="2"><span class="small">$modtxt{'1'} $games{'admin2'}</span></td>
		</tr><tr>
			<td class="windowbg2"><img src="$defaultimagesdir/$status_games" alt="" /> $games{'admin4'}</td>
			<td class="windowbg2"><input type="checkbox" name="games_active" $ongamesactchecked /></td>
		</tr><tr>
			<td class="windowbg2">$games{'admin15'}</td>
			<td class="windowbg2"><input type="checkbox" name="games_popup"$games_popup_checked /></td>
		</tr><tr>
			<td class="windowbg2">$games{'admin5'}</td>
			<td class="windowbg2">
				<select name="showgamesbutton" size="1">
					<option value="0"$cgam1>$games{'admin6'}</option>
					<option value="1"$cgam2>$games{'admin7'}</option>
					<option value="2"$cgam3>$games{'admin8'}</option>
				</select>
			</td>
		</tr><tr>
			<td class="windowbg2">$games{'admin14'}</td>
			<td class="windowbg2">
            <select multiple="multiple" name="displaygames" size="5">\n~;

    @ExistGames = sort @ExistGames;
    $i = 0;
    foreach my $elementgames (@ExistGames) {
        chomp $elementgames;
        $playinfo1="1_".$elementgames;
        $play_info_1 = $games{$playinfo1};
        foreach my $element (split /\,/xsm, $DisplayGames) {
            chomp $element;
            if ($element eq $elementgames) { $i = ' selected="selected"'; }
        }
            $yymain .= qq~    <option value="$elementgames"$i>$play_info_1</option>\n~;
    $i++;
    }
    $yymain .= qq~</select>
			</td>
		</tr><tr>
			<td class="windowbg2">$games$games{'admin9'}<br /><span class="small">$games{'admin10'}</span></td>
			<td class="windowbg2">
				<select multiple="multiple" name="gamesperms" size="5">$gamesperms</select>
			</td>
		</tr><tr>
			<td class="windowbg2">$games{'admin11'}<br /><span class="small">$games{'admin12'}</span></td>
			<td class="windowbg2"><input type="text" name="gamesusers" size="35" value="$GamesUsers" /></td>
		</tr>
	</table>
</div>
    <div class="bordercolor rightboxdiv">
    <table class="border-space pad-cell" style="margin-bottom: .5em;">
		<tr>
            <th class="titlebg"><img src="$imagesdir/preferences.gif" alt="" /> $admin_txt{'10'}</th>
        </tr><tr>
			<td class="catbg center">
				<input type="submit" name="savesetting" value="$games{'admin13'}" class="button" />
			</td>
		</tr>
	</table>
</div>
</form>
~;

    $yytitle     = $games{'admin1'};
    $action_area = 'games_set';
    AdminTemplate();
    exit;
}

## Save Online Games Setting ##

sub GamesSet2 {
    is_admin_or_gmod();

    my @onoff = qw/games_active games_popup/;

    # Set as 0 or 1 if box was checked or not
    my $fi;
    map { $fi = lc $_; ${$_} = $FORM{$fi} eq 'on' ? 1 : 0; } @onoff;


    # If empty fields are submitted, set them to default-values to save yabb from crashing

    $showgamesbutton = $FORM{'showgamesbutton'} || 0;
    $gamesperms = $FORM{'gamesperms'}       || q{};
    $gamesperms =~ s~\A\s?,\s?~~;
    $gamesperms =~ s~,\s~,~g;
    $gamesusers = $FORM{'gamesusers'}       || q{};
    $gamesusers =~ s~\A\s?,\s?~~;
    $gamesusers =~ s~,\s~,~g;
    $displaygames = $FORM{'displaygames'}       || q{};
    $displaygames =~ s~\A\s?,\s?~~;
    $displaygames =~ s~,\s~,~g;

    my $filler  = q~                                                                               ~;
    my $setfile = << "EOF";
###############################################################################
# onlinegames.txt                                                             #
###############################################################################

## Games Setting ##

\$Games_Active = $games_active;
\$Show_GamesButton = $showgamesbutton;
\$GamesPopup = $games_popup;
\$GamesPerms = qq~$gamesperms~;
\$GamesUsers = qq~$gamesusers~;
\$DisplayGames = qq~$displaygames~;

1;
EOF

    $setfile =~ s~(.+\;)\s+(\#.+$)~$1 . substr( $filler, 0, (70-(length $1)) ) . $2 ~gem;
    $setfile =~ s~(.{64,}\;)\s+(\#.+$)~$1 . "\n   " . $2~gem;
    $setfile =~ s~^\s\s\s+(\#.+$)~substr( $filler, 0, 70 ) . $1~gem;

    fopen(FILE, ">$vardir/Mods/onlinegames.txt");
    print {FILE} $setfile;
    fclose(FILE);

    $yySetLocation = qq~$adminurl?action=games_set~;
    redirectexit();
}

1;
