###############################################################################
# Games.pm                                                                    #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.6.11                                                 #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2015 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################

$gamesplver = 'YaBB 2.6.11 $Revision: 1.02 $';
if ($action eq 'detailedversion') { return 1; }

LoadLanguage('Mods/Games');

sub PlayGames {
    require "$vardir/Mods/onlinegames.txt";

    $thisgame = $INFO{'thisgame'};

#<--------------------------------------------->#
# Access check to play the games
#<--------------------------------------------->#
    $Allow_Game_Play = 0;

    if ($GamesPerms) {
        $memberinform = $memberunfo{$username};
        foreach $element (split /\,/xsm, $GamesPerms) {
            chomp $element;
            if (($element eq ${$uid.$username}{'position'}) || ($element eq $memberinform)) { $Allow_Game_Play = 1; last; }
                $memberaddgroup{$username} =~ s/\, /\,/g;
                foreach $memberaddgroups (split /\,/xsm, $memberaddgroup{$username}) {
                    chomp $memberaddgroups;
                    if ($element eq $memberaddgroups) { $Allow_Game_Play = 1; last; }
                }
            if ($Allow_Game_Play == 1) { last; }
        }
    }

    if ($Allow_Game_Play != 1) {
        $Allow_Game_Play = 0;

        if ($GamesUsers) {
            foreach $elementusers (split /\,/xsm, $GamesUsers) {
                chomp $elementusers;
                if ($elementusers eq $username) { $Allow_Game_Play = 1; last; }
                if ($Allow_Game_Play == 1) { last; }
            }
        }
    }


    if ($iamadmin) { $Allow_Game_Play = 1; }
    if (($iamguest) && ($GamesPerms || $GamesUsers)) { $Allow_Game_Play = 0; }
    if ($GamesPerms eq q{}) { $Allow_Game_Play = 1; }

    if (!$Allow_Game_Play) { fatal_error($games{'game2'}); }

#<--------------------------------------------->#
# Access check to play the games end
#<--------------------------------------------->#
    $playinfo1='1_'.$thisgame;
    $play_info_1=$games{$playinfo1};
    $playinfo2='2_'.$thisgame;
    $play_info_2=$games{$playinfo2};
    $playinfo3='3_'.$thisgame;
    $play_info_3=$games{$playinfo3};
    $playinfo4='4_'.$thisgame;
    $play_info_4=$games{$playinfo4};
    $playinfo5='5_'.$thisgame;
    $play_info_5=$games{$playinfo5};
    $playinfo6='6_'.$thisgame;
    $play_info_6=$games{$playinfo6};

    if ($thisgame && $play_info_3 =~ /java/ixsm) {
        $Games_Code .= qq~
<div class="bordercolor">
<table class="tabtitle">
    <tr>
        <td style="padding-left:1%">
            <img src="$modimgurl/Games/onlinegames.gif" alt="" /> <b>$play_info_1:</b> <span class="small">$play_info_2</span>
        </td>
    </tr>
</table>
<table class="pad_4px cs_thin">
      <tr>
        <td class="windowbg">
        <b>$games{'game3'}:</b><br /><br />$play_info_6<br /><br />
        </td>
      </tr><tr>
        <td class="windowbg2 center">
        <iframe width="$play_info_4" height="$play_info_5" style="border:0" scrolling="no" src="$modimgurl/Games/$thisgame/$thisgame.htm"></iframe>
        </td>
  </tr>
</table>
</div>
<br />
~;
    }

    if ($thisgame && $play_info_3 =~ /flash/ixsm) {
        # open and read  file
        fopen (FLASHGAME,"$modimgdir/Games/$thisgame/$thisgame.dat");
        @GAMEFILE = <FLASHGAME>;
        fclose (FLASHGAME);

        # News lines
        foreach $entry (@GAMEFILE){
            ($xtcline) = split /\n/, $entry;

            $xtcline =~ s|<gamesurl>|$modimgurl/Games|gism;
            $xtcgameout .= qq~$xtcline\n~;
        }

        $Games_Code .= qq~
<div class="bordercolor">
<table class="tabtitle">
    <tr>
        <td style="padding-left:1%">
            <img src="$modimgurl/Games/onlinegames.gif" alt="" /> <b>$play_info_1:</b> <span class="small">$play_info_2</span>
        </td>
    </tr>
</table>
<table class="pad_4px cs_thin">
    <tr>
        <td class="windowbg vtop">
        <b>$games{'game3'}:</b><br /><br />$play_info_6<br /><br />
        </td>
      </tr><tr>
        <td class="windowbg2 center vtop">
        $xtcgameout
        </td>
  </tr>
</table>
</div>
<br />
~;
    }

    if ($GamesPopup != 1){ $yymain .= qq~$Games_Code~; }

    if ($GamesPopup == 1 && $thisgame) {
        $headers .= "Content-type: text/html\n";
        if( $yySetCookies ) { $headers .= $yySetCookies; }
        $headers .= "\n";
        print $headers;
        print qq~
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>$games{'game1'}</title>
<link rel="stylesheet" href="$yyhtml_root/Templates/Forum/$usestyle.css" type="text/css" />
</head>
<body>
    <table class="pad_2px cs_thin">
        <tr>
            <td class="center">
            <div id="container">
            $Games_Code
            </div>
            </td>
        </tr>
    </table>
    <center><a href="javascript:window.close()">[$games{'game5'}]</a></center><br />
</body>
</html>~;
        exit;
    }


    $yymain .= qq~
<div class="bordercolor">
<table class="tabtitle">
    <tr>
        <td style="padding-left:1%">
            <img src="$modimgurl/Games/onlinegames.gif" alt="" /> <b>$games{'game1'}</b>
        </td>
    </tr>
</table>
<table class="pad_4px cs_thin">
    <tr>
        <td class="windowbg" colspan="2">
        <b>$games{'game4'}:</b>
        </td>
      </tr>
~;


    foreach my $elementgames (split /\,/xsm, $DisplayGames) {
        chomp $elementgames;

        $playinfo1='1_'.$elementgames;
        $play_info_1=$games{$playinfo1};
        $playinfo2='2_'.$elementgames;
        $play_info_2=$games{$playinfo2};
        $playinfo3='3_'.$elementgames;
        $play_info_3=$games{$playinfo3};
        $playinfo4='4_'.$thisgame;
        $play_info_4=$games{$playinfo4};
        $playinfo5='5_'.$thisgame;
        $play_info_5=$games{$playinfo5};

        if ($play_info_4 < 700) { $play_info_4 = 700; }
        if ($play_info_5 < 550) { $play_info_5 = 550; }

        if ($GamesPopup == 1){
            $games_list .= qq~<tr><td class="windowbg"><a href="javascript:void(0)" onclick="window.open('$scripturl?action=play_game;thisgame=$elementgames','cutecast','toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=1,width=$play_info_4,height=$play_info_5,top=0,left=0');"> $play_info_1 ($play_info_3)</a></td><td class="windowbg2">$play_info_2</td></tr>~;
        } else {
            $games_list .= qq~<tr><td class="windowbg"><a href="$scripturl?action=play_game;thisgame=$elementgames"> $play_info_1 ($play_info_3)</a></td><td class="windowbg2">$play_info_2</td></tr>~;
        }
    }

    $yymain .= qq~
    $games_list
</table>
</div>
~;

    $yytitle = "$games{'game1'}";
    template();
    exit;
}

1;